import 'package:addresspicker_packages/Address.dart';
import 'package:addresspicker_packages/addresspicker_package.dart';
import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:addresspicker_packages/addresspicker_packages.dart';
import 'package:get/get.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      platformVersion = await AddresspickerPackages.platformVersion;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(home: AddressPicker());
  }
}

class AddressPicker extends StatefulWidget {
  @override
  _AddressPickerState createState() => _AddressPickerState();
}

class _AddressPickerState extends State<AddressPicker> {
  List<Address> provinceList = [
    Address(code: '1', name: 'province1'),
    Address(code: '2', name: 'province2'),
    Address(code: '3', name: 'province3'),
    Address(code: '4', name: 'province4'),
    Address(code: '5', name: 'province5'),
  ];
  List<Address> districtList = [
    Address(code: '1', name: 'distri1'),
    Address(code: '2', name: 'distri2'),
    Address(code: '3', name: 'distri3'),
    Address(code: '4', name: 'distri4'),
    Address(code: '5', name: 'distri5'),
  ];
  List<Address> villageList = [
    Address(code: '1', name: 'village1'),
    Address(code: '2', name: 'village2'),
    Address(code: '3', name: 'village3'),
    Address(code: '4', name: 'village4'),
    Address(code: '5', name: 'village5'),
  ];
  List<Address> communeList = [
    Address(code: '1', name: 'commun1'),
    Address(code: '2', name: 'commun2'),
    Address(code: '3', name: 'commun3'),
    Address(code: '4', name: 'commun4'),
    Address(code: '5', name: 'commun5'),
  ];
  List<Address> listData = [];
  Address city;
  Address district;
  Address commune;
  Address village;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Address Picker'),
      ),
      body: Container(
        child: GestureDetector(
            child: Text('ShowAddress'),
            onTap: () {
              listData.clear();
              onShowAddressPicker(
                  gridIndex: 2,
                   //initial value
                   city: city,
                   commune: district,
                  district: commune,
                  village: village,
                  context: context,
                  onCancel: () {
                    Navigator.pop(context);
                    Navigator.pop(context);
                  },
                  onSelectProvince: (Address province) {
                    print(province.name);
                    setState(() {

                      listData.add(province);
                    });
                  },
                  onSelectCommune: (Address commune) {
                    setState(() {
                      listData.add(commune);
                    });
                  },
                  onSelectDistrict: (Address disctrict) {
                    setState(() {
                      listData.add(disctrict);
                    });
                  },
                  onSelectVillage: (Address village) {
                    setState(() {
                      if(listData.length!=4)
                        listData.add(village);
                         else {
                        listData[3] = village;
                             }
                    });
                  },
                  //list all value
                  selectAddress: listData,
                  communeList: communeList,
                  provinceList: provinceList,
                  villageList: villageList,
                  districtList: districtList,
                  onSave: () {
                    city=listData[0];
                    district=listData[1];
                    commune=listData[2];
                    village=listData[3];
                  });
            }),
      ),
    );
  }
}
