
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'dart:io' show Platform;
import 'package:flutter/foundation.dart' show kIsWeb;
import 'package:flutter_svg/svg.dart';

class CustomButton extends StatefulWidget {
  final String title;
  final Function onPressed;
  bool isDisable = false;
  bool isOutline = false;
  final iconUrl;
  CustomButton(
      {this.title,
        this.onPressed,
        this.isDisable,
        this.isOutline,
        this.iconUrl});

  @override
  _CustomButtonState createState() => _CustomButtonState();
}

class _CustomButtonState extends State<CustomButton> {
  @override
  Widget build(BuildContext context) {
    // return Container(
    //     width: double.infinity,
    //     child: Platform.isIOS
    //         ? CupertinoButton(
    //             color: AppColor.mainColor,
    //             child: Text(
    //               title,
    //               style: Theme.of(context).textTheme.button,
    //             ),
    //             onPressed: onPressed,
    //           )
    //         : Platform.isAndroid
    // ?
    //             : kIsWeb
    //                 ? Container(
    //                     child: RaisedButton(
    //                       shape: RoundedRectangleBorder(
    //                         borderRadius: BorderRadius.circular(8.0),
    //                       ),
    //                       padding: const EdgeInsets.symmetric(vertical: 15.0),
    //                       color: AppColor.mainColor,
    //                       child: Text(
    //                         title,
    //                         style: Theme.of(context).textTheme.button,
    //                       ),
    //                       onPressed: onPressed,
    //                     ),
    //                   )
    //                 : Container());

    return kIsWeb
        ? Container(
      height: 50,
      width: double.infinity,
      child: RaisedButton(
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(8.0),
        ),
        padding: const EdgeInsets.symmetric(vertical: 15.0),
        color: Color(0xff0F50A4),
        child: Text(
          widget.title,
          style: Theme.of(context).textTheme.button,
        ),
        onPressed: widget.onPressed,
      ),
    )
        : Platform.isAndroid
        ? Container(
      height: 50,
      width: double.infinity,
      child: !widget.isDisable && !widget.isOutline
          ? RaisedButton(
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(8.0),
        ),
        padding: const EdgeInsets.symmetric(vertical: 15.0),
        color: Color(0xff0F50A4),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            widget.iconUrl != null
                ? SvgPicture.asset(widget.iconUrl)
                : Container(),
            if (widget.iconUrl != null)
              SizedBox(
                width: 15,
              ),
            Text(
              widget.title,
              style: Theme.of(context).textTheme.button,
            ),
          ],
        ),
        onPressed: widget.onPressed,
      )
          : widget.isOutline && !widget.isDisable
          ? OutlineButton(
        color: Theme.of(context).primaryColor,
        borderSide: BorderSide(
            width: 2,
            color: Theme.of(context).primaryColor),
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(
            8.0,
          ),
        ),
        padding: const EdgeInsets.symmetric(vertical: 15.0),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            widget.iconUrl != null
                ? SvgPicture.asset(widget.iconUrl)
                : Container(),
            if (widget.iconUrl != null)
              SizedBox(
                width: 15,
              ),
            Text(
              widget.title,
              style: TextStyle(
                  fontFamily: 'DMSans',
                  fontSize: 16,
                  fontWeight: FontWeight.bold,
                  color: Theme.of(context).primaryColor),
            ),
          ],
        ),
        onPressed: widget.onPressed,
      )
          : RaisedButton(
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(8.0),
        ),
        padding: const EdgeInsets.symmetric(vertical: 15.0),
        color: Color(0xff0F50A4),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            widget.iconUrl != null
                ? SvgPicture.asset(widget.iconUrl)
                : Container(),
            if (widget.iconUrl != null)
              SizedBox(
                width: 15,
              ),
            Text(
              widget.title,
              style: Theme.of(context).textTheme.button,
            ),
          ],
        ),
        onPressed: widget.onPressed,
      ),
    )
        : Platform.isIOS
        ? Container(
      height: 50,
      width: double.infinity,
      child: !widget.isDisable && !widget.isOutline
          ? CupertinoButton(
        padding: EdgeInsets.symmetric(horizontal: 0),
        color: Color(0xff0F50A4),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            widget.iconUrl != null
                ? SvgPicture.asset(widget.iconUrl)
                : Container(),
            if (widget.iconUrl != null)
              SizedBox(
                width: 15,
              ),
            Text(
              widget.title,
              style: Theme.of(context).textTheme.button,
            ),
          ],
        ),
        onPressed: widget.onPressed,
      )
          : widget.isOutline && !widget.isDisable
          ? GestureDetector(
        onTap: widget.onPressed,
        child: Container(
          padding: EdgeInsets.all(12),
          width: double.infinity,
          alignment: Alignment.center,
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment:
            CrossAxisAlignment.center,
            children: [
              widget.iconUrl != null
                  ? SvgPicture.asset(widget.iconUrl)
                  : Container(),
              if (widget.iconUrl != null)
                SizedBox(
                  width: 15,
                ),
              Text(
                widget.title,
                style: TextStyle(
                    fontFamily: 'DMSans',
                    fontSize: 16,
                    fontWeight: FontWeight.bold,
                    color:
                    Theme.of(context).primaryColor),
              ),
            ],
          ),
          decoration: BoxDecoration(
              border: Border.all(
                  color:
                  Theme.of(context).primaryColor),
              borderRadius: BorderRadius.circular(10)),
        ),
      )
          : widget.isDisable && !widget.isOutline
          ? CupertinoButton(
        padding:
        EdgeInsets.symmetric(horizontal: 0),
        color: Color(0xff0F50A4),
        child: Text(
          widget.title,
          style: Theme.of(context).textTheme.button,
        ),
        onPressed: null,
      )
          : CupertinoButton(
        padding:
        EdgeInsets.symmetric(horizontal: 0),
        color:Color(0xff0F50A4),
        child: Text(
          widget.title,
          style: Theme.of(context).textTheme.button,
        ),
        onPressed: null,
      ),
    )
        : Container();
  }
}
