import 'dart:core';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'Address.dart';
import 'CustomButton.dart';
import 'CustomChips.dart';

onShowAddressPicker({
  BuildContext context,
  List<Address> provinceList,
  List<Address> districtList,
  List<Address> communeList,
  List<Address> villageList,
  List<Address> selectAddress,
  Function onSelectProvince,
  Function onSelectDistrict,
  Function onSelectCommune,
  Function onSelectVillage,
  Function onCancel,
  Function onSave,
  int gridIndex,
  Address city,
  Address district,
  Address commune,
  Address village,

}) async {
  int provinceIndex;
  int districtIndex;
  int communeIndex;
  int villageIndex;
  final _formKey = GlobalKey<FormState>();

  if(city!=null)
  if (city.code != '') {
    provinceIndex = provinceList.indexOf(city);
    selectAddress.add(city);
  }

  if(district!=null)
  if (district.code != '') {
    districtIndex = districtList.indexOf(district);
    selectAddress.add(district);
  }
  if(commune!=null)
  if (commune.code != '') {
    communeIndex = communeList.indexOf(commune);
    selectAddress.add(commune);
  }
  if(village!=null)
  if (village.code != '') {
    villageIndex = villageList.indexOf(village);
    selectAddress.add(village);
  }
  showModalBottomSheet(
      isScrollControlled: true,
      backgroundColor: Color(0xff737373),
      context: context,
      isDismissible: false,
      enableDrag: false,
      useRootNavigator: false,
      builder: (context) {
        return FractionallySizedBox(
          heightFactor: 0.9,
          child: StatefulBuilder(
            builder: (context, setMyState) {
              print('leangh :${provinceList.length}');
              List<Widget> gridList = [
                Container(
                  child: GridView.builder(
                    physics: NeverScrollableScrollPhysics(),
                    padding: EdgeInsets.symmetric(horizontal: 20),
                    shrinkWrap: true,
                    itemCount: provinceList.length,
                    gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                        crossAxisCount: 2,
                        crossAxisSpacing: 15,
                        mainAxisSpacing: 15,
                        childAspectRatio: 4 / 1.3),
                    itemBuilder: (context, index) {
                      return GestureDetector(
                        onTap: () {
                          onSelectProvince(provinceList[index]);
                          setMyState(() {
                            provinceIndex = index;
                            // districtList.clear();
                            // onFetchDistrict()
                          });
                        },
                        child: CustomChips(
                          padding: EdgeInsets.symmetric(
                              horizontal: 10, vertical: 15),
                          title: provinceList[index]
                              .name
                              .replaceAll('Province', ''),
                          currentIndex: index,
                          selectIndex: provinceIndex,
                        ),
                      );
                    },
                  ),
                ),
                GridView.builder(
                  physics: NeverScrollableScrollPhysics(),
                  padding: EdgeInsets.symmetric(horizontal: 20),
                  shrinkWrap: true,
                  itemCount: districtList.length,
                  gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                      crossAxisCount: 2,
                      crossAxisSpacing: 15,
                      mainAxisSpacing: 15,
                      childAspectRatio: 4 / 1.3),
                  itemBuilder: (context, index) {
                    return districtList.length != 0
                        ? GestureDetector(
                      onTap: () {
                        onSelectDistrict(districtList[index]);
                        setMyState(() {
                          districtIndex = index;
                          // communeList.clear();
                          // reqCon.getCommune(
                          //     reqCon.districtList[index].code, 'en');

                          // if (!reqCon.currentAddressList
                          //     .contains(reqCon.districtList[index])) {
                          //   reqCon.currentAddressList
                          //       .add(reqCon.districtList[index]);
                          // }
                        });
                      },
                      child: CustomChips(
                        padding: EdgeInsets.symmetric(
                            horizontal: 10, vertical: 15),
                        title: districtList[index].name,
                        currentIndex: index,
                        selectIndex: districtIndex,
                      ),
                    )
                        : Center(
                      child: CircularProgressIndicator(),
                    );
                  },
                ),
                GridView.builder(
                  physics: NeverScrollableScrollPhysics(),
                  padding: EdgeInsets.symmetric(horizontal: 20),
                  shrinkWrap: true,
                  itemCount: communeList.length,
                  gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                      crossAxisCount: 2,
                      crossAxisSpacing: 15,
                      mainAxisSpacing: 15,
                      childAspectRatio: 4 / 1.3),
                  itemBuilder: (context, index) {
                    return communeList.length != 0
                        ? GestureDetector(
                      onTap: () {
                        onSelectCommune(communeList[index]);
                        setMyState(() {
                          communeIndex = index;
                          // reqCon.villageList.clear();
                          // reqCon.getVillage(
                          //     reqCon.communeList[index].code, 'en');

                          // if (!reqCon.currentAddressList
                          //     .contains(reqCon.communeList[index])) {
                          //   reqCon.currentAddressList
                          //       .add(reqCon.communeList[index]);
                          // }
                        });
                      },
                      child: CustomChips(
                        padding: EdgeInsets.symmetric(
                            horizontal: 10, vertical: 15),
                        title: communeList[index].name,
                        currentIndex: index,
                        selectIndex: communeIndex,
                      ),
                    )
                        : Center(
                      child: CircularProgressIndicator(),
                    );
                  },
                ),
                GridView.builder(
                  physics: NeverScrollableScrollPhysics(),
                  padding: EdgeInsets.symmetric(horizontal: 20),
                  shrinkWrap: true,
                  itemCount: villageList.length,
                  gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                      crossAxisCount: 2,
                      crossAxisSpacing: 15,
                      mainAxisSpacing: 15,
                      childAspectRatio: 4 / 1.3),
                  itemBuilder: (context, index) {
                    return villageList.length != 0
                        ? GestureDetector(
                      onTap: () {
                        onSelectVillage(villageList[index]);
                        setMyState(() {
                          villageIndex = index;
                        });
                      },
                      child: CustomChips(
                        padding: EdgeInsets.symmetric(
                            horizontal: 10, vertical: 15),
                        title: villageList[index].name,
                        currentIndex: index,
                        selectIndex: villageIndex,
                      ),
                    )
                        : Center(
                      child: CircularProgressIndicator(),
                    );
                  },
                ),
              ];
              return Material(
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.only(
                      topRight: Radius.circular(15),
                      topLeft: Radius.circular(15)),
                ),
                child: Container(
                  // decoration: BoxDecoration(
                  //     color: Colors.black,
                  //     borderRadius: BorderRadius.only(
                  //         topRight: Radius.circular(10),
                  //         topLeft: Radius.circular(10))),
                  // margin: EdgeInsets.symmetric(vertical: 20),
                  height: double.infinity,
                  width: double.infinity,
                  child: Stack(
                    children: [
                      Positioned.fill(
                        bottom: 80,
                        left: 0,
                        right: 0,
                        top: 0,
                        child: SingleChildScrollView(
                          child: Form(
                            key: _formKey,
                            child: Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              mainAxisAlignment: MainAxisAlignment.start,
                              children: [

                                Padding(
                                  padding: const EdgeInsets.symmetric(
                                      horizontal: 20, vertical: 10),
                                  child: Text(
                                    'Location',
                                    style: TextStyle(
                                        fontSize: 16,
                                        fontWeight: FontWeight.bold,
                                        fontFamily: 'DMSans'),
                                  ),
                                ),
                                Container(
                                  padding: EdgeInsets.symmetric(
                                    horizontal: 20,
                                  ),
                                  child: Wrap(
                                    alignment: WrapAlignment.start,
                                    crossAxisAlignment:
                                    WrapCrossAlignment.start,
                                    children: selectAddress
                                        .asMap()
                                        .entries
                                        .map(
                                          (e) => Padding(
                                        padding: const EdgeInsets.only(
                                            right: 10, bottom: 10),
                                        child: InputChip(
                                            shape: RoundedRectangleBorder(
                                                borderRadius:
                                                BorderRadius.circular(
                                                    5)),
                                            showCheckmark: false,
                                            deleteIcon: Icon(Icons.cancel),
                                            labelPadding: EdgeInsets.all(5),
                                            onPressed: () {},
                                            selectedColor:
                                            Color(0xffB3C6E0),
                                            selected: true,
                                            labelStyle: TextStyle(
                                                color: Theme.of(context)
                                                    .primaryColor,
                                                fontWeight:
                                                FontWeight.bold),
                                            deleteIconColor:
                                            Theme.of(context)
                                                .primaryColor,
                                            onDeleted: e.key !=
                                                selectAddress.length - 1
                                                ? null
                                                : () {
                                              setMyState(() {
                                                selectAddress
                                                    .remove(e.value);
                                                if (e.key == 2) {
                                                  setMyState(() {
                                                    villageIndex = -1;
                                                  });
                                                }
                                                if (e.key == 1) {
                                                  setMyState(() {
                                                    communeIndex = -1;
                                                  });
                                                }
                                                if (e.key == 0) {
                                                  setMyState(() {
                                                    districtIndex =
                                                    -1;
                                                    provinceIndex =
                                                    -1;
                                                  });
                                                }
                                              });
                                            },
                                            label: Text(
                                              e.value.name.replaceAll(
                                                  'Province', ''),
                                              style:
                                              TextStyle(fontSize: 12),
                                            )),
                                      ),
                                    )
                                        .toList(),
                                  ),
                                ),
                                SizedBox(
                                  height: 10,
                                ),
                                selectAddress.length <= 3
                                    ? gridList.elementAt(selectAddress.length)
                                    : gridList.elementAt(3),
                                // gridList.elementAt(1)
                              ],
                            ),
                          ),
                        ),
                      ),
                      Positioned(
                        bottom: 20,
                        left: 20,
                        right: 20,
                        child: Row(
                          children: [
                            Expanded(
                              child: CustomButton(
                                isDisable: false,
                                isOutline: true,
                                onPressed: () {
                                  if (selectAddress.length != 0) {
                                    showCupertinoDialog(
                                        context: context,
                                        builder: (context) {
                                          return CupertinoAlertDialog(
                                            title: Text(
                                                'Are you sure you want to go back this page?'),
                                            content: Text(
                                                'change made to this page haven\'t been save yet'),
                                            actions: [
                                              CupertinoButton(
                                                  child: Text('Yes'),
                                                  onPressed: onCancel),
                                              CupertinoButton(
                                                child: Text('No'),
                                                onPressed: () {
                                                  Navigator.pop(context);
                                                },
                                              )
                                            ],
                                          );
                                        });
                                  } else {
                                    Navigator.pop(context);
                                  }
                                },
                                title: 'Cancel',
                              ),
                            ),
                            SizedBox(
                              width: 20,
                            ),
                            Expanded(
                              child: CustomButton(
                                isDisable:
                                selectAddress.length >= 3 ? false : true,
                                isOutline: false,
                                onPressed: selectAddress.length <= 3
                                    ? null
                                    : () {
                                  _formKey.currentState.save();
                                  setMyState(() {
                                    onSave();
                                    selectAddress.clear();
                                  });

                                  Navigator.pop(
                                      context, );
                                },
                                title: 'Apply',
                              ),
                            ),
                          ],
                        ),
                      )
                    ],
                  ),
                ),
              );
            },
          ),
        );
      });

}